## mingw-w64-gpr-24.0.0-2.src.tar.zst

=== Makefile ===
##############################################################################
##                                                                          ##
##                            GPR2 PROJECT LIBRARY                          ##
##                                                                          ##
##          Copyright (C) 2016-2022, Free Software Foundation, Inc.         ##
##                                                                          ##
## This library is free software;  you can redistribute it and/or modify it ##
## under terms of the  GNU General Public License  as published by the Free ##
## Software  Foundation;  either version 3,  or (at your  option) any later ##
## version. This library is distributed in the hope that it will be useful, ##
## but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN# ##
## TABILITY or FITNESS FOR A PARTICULAR PURPOSE.                            ##
##                                                                          ##
## As a special exception under Section 7 of GPL version 3, you are granted ##
## additional permissions described in the GCC Runtime Library Exception,   ##
## version 3.1, as published by the Free Software Foundation.               ##
##                                                                          ##
## You should have received a copy of the GNU General Public License and    ##
## a copy of the GCC Runtime Library Exception along with this program;     ##
## see the files COPYING3 and COPYING.RUNTIME respectively.  If not, see    ##
## <http://www.gnu.org/licenses/>.                                          ##
##                                                                          ##
##############################################################################

# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build libgpr2:           make
# Install libgpr2:         make install

# Variables which can be set:
#
#   prefix        : root install directory
#   ENABLE_SHARED : yes / no (or empty)
#   GPR2_BUILD    : debug / release / release_checks / gnatcov
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   PROFILER      : Include gprof support instrumentation (yes / no)
#   TARGET        : target triplet for cross-compilation
#   LOCAL_GPR2    : whether tools should be built with the local gpr2
#                   project or use an installed one. (yes/no)

HOST    = $(shell gcc -dumpmachine)
TARGET := $(shell gcc -dumpmachine)

# Look for the source directory (in case of out-of-tree builds):
#
# first let's check if Makefile is symlinked: realpath will return the actual
# (after link resolution) relative path of the Makefile from PWD.
MFILE         := $(shell realpath --relative-to=. "$(firstword ${MAKEFILE_LIST})"))
# as Makefile is in the root dir, SOURCE_DIR is just dirname of the Makefile
# path above.
SOURCE_DIR    := $(shell dirname "${MFILE}")

prefix	      := $(dir $(shell which gnatls))..
GPR2_BUILD     = release
PROCESSORS     = 0
PROFILER       = no
LOCAL_GPR2     = yes
GPRINSTALL     = gprinstall
PYTHON         = python

# Prefix to use for non-productized tools
GPR2_EDGE_TOOLS_PREFIX=gpr2

# Whether we want to force a (re-)generation of the langkit parser.
# Set this to "force" to regenerate the parser.
FORCE_PARSER_GEN=

GPR2=${SOURCE_DIR}/gpr2.gpr
GPR2TOOLS=${SOURCE_DIR}/tools/gpr2-tools.gpr
GPR2KB=${SOURCE_DIR}/src/kb/collect_kb.gpr
GPR2KBDIR=${SOURCE_DIR}/src/kb/gprconfig_kb

# check for out-of-tree build
ifeq (${SOURCE_DIR},.)
BUILD_ROOT=.build
else
BUILD_ROOT=.
endif
LANGKIT_GENERATED_SRC=${BUILD_ROOT}/lkparser
KB_BUILD_DIR=${BUILD_ROOT}/kb
GNATCOV_LEVEL=stmt

ENABLE_SHARED := $(shell gprbuild ${GTARGET} -c -q -p \
        -XBUILD_ROOT="${CURDIR}/${BUILD_ROOT}" \
        -P${SOURCE_DIR}/config/test_shared 2>/dev/null && echo "yes")

# Used to pass extra options to GPRBUILD, like -d or -v for instance
GPRBUILD_OPTIONS=

# Load current setup if any
-include makefile.setup

# target options for cross-build
ifeq (${HOST},${TARGET})
GTARGET=
else
GTARGET=--target=${TARGET}
endif

LIBGPR2_TYPES=static
ifeq (${ENABLE_SHARED},yes)
ifneq (${GPR2_BUILD},gnatcov)
   LIBGPR2_TYPES=static relocatable static-pic
endif
endif

AP_GPR2=
BUILD_LIBGPR2=
ifeq (${LOCAL_GPR2},yes)
  AP_GPR2=-aP ${SOURCE_DIR}
  BUILD_LIBGPR2=build-lib-static
endif

BUILD_TYPES=debug release release_checks gnatcov

ifneq (${GPR2_BUILD},gnatcov)
   COVERAGE_BUILD_FLAGS=
else
   COVERAGE_BUILD_FLAGS= \
           --implicit-with=gnatcov_rts \
           --src-subdirs=gnatcov-instr
   COVERAGE_INSTR_FLAGS= -XGPR2_BUILD=${GPR2_BUILD} \
           -XBUILD_ROOT="${CURDIR}/${BUILD_ROOT}" \
           -XLIBRARY_TYPE=static -XXMLADA_BUILD=static
   COVERAGE_INSTR=gnatcov instrument --level $(GNATCOV_LEVEL) \
           --dump-trigger=atexit \
            ${COVERAGE_INSTR_FLAGS}
endif

GPR_OPTIONS=${GTARGET} -XGPR2_BUILD=${GPR2_BUILD} \
        -XGPR2_EDGE_TOOLS_PREFIX=${GPR2_EDGE_TOOLS_PREFIX} \
        -XBUILD_ROOT="${CURDIR}/${BUILD_ROOT}"

BUILDER=gprbuild -p -m -j${PROCESSORS} ${GPR_OPTIONS} ${GPRBUILD_OPTIONS} \
             -XPROFILER=${PROFILER} ${COVERAGE_BUILD_FLAGS}
INSTALLER=${GPRINSTALL} -p -f ${GPR_OPTIONS} --prefix='${prefix}'
CLEANER=gprclean -eL -p ${RBD} -XGPR2_BUILD=${GPR2_BUILD} \
        -XBUILD_ROOT="${CURDIR}/${BUILD_ROOT}"
UNINSTALLER=${INSTALLER} -p -f --uninstall

# doc generation

GPRDOC=${BUILD_ROOT}/${GPR2_BUILD}/gprdoc
DOCOUT=${BUILD_ROOT}/attributes.json

.PHONY: force doc

#########
# build #
#########

all: ${LIBGPR2_TYPES:%=build-lib-%} build-tools

# Knowledge base
${KB_BUILD_DIR}:
	mkdir -p ${KB_BUILD_DIR}

${KB_BUILD_DIR}/config.kb: ${KB_BUILD_DIR} $(wildcard $(GPR2KBDIR)/*)
	gprbuild -p -P ${GPR2KB} -XKB_BUILD_DIR=${KB_BUILD_DIR} --relocate-build-tree
	${KB_BUILD_DIR}/collect_kb -o $@ ${GPR2KBDIR}

# Libgpr2
build-lib-%: ${KB_BUILD_DIR}/config.kb
ifneq (${GPR2_BUILD},gnatcov)
	${BUILDER} -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* \
		${GPR2}
else
	echo "gpr2 library built from gpr2-tools in gnatcov mode"
endif

# Gpr2 tools
build-tools: ${BUILD_LIBGPR2} coverage-instrument
	${BUILDER} -XLIBRARY_TYPE=static -XXMLADA_BUILD=static \
		${GPR2TOOLS} ${AP_GPR2}

# Gnatcov instrumentation
coverage-instrument:
ifeq (${GPR2_BUILD},gnatcov)
# Remove artifacts from previous instrumentations, so that stale units
# that are not overriden by new ones don't get in our way.
	rm -rf "${BUILD_ROOT}/${GPR2_BUILD}/obj-*/*gnatcov-instr"
	mkdir -p "${BUILD_ROOT}/${GPR2_BUILD}"

	${COVERAGE_INSTR} -P ${GPR2TOOLS}
endif

###########
# Install #
###########

uninstall-libs:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/gpr2))
	${UNINSTALLER} $(notdir ${GPR2})
endif

uninstall-tools:
ifneq (,$(wildcard $(prefix)/share/gpr/manifests/gpr2-tools))
	${UNINSTALLER} $(notdir ${GPR2TOOLS})
endif

install: uninstall-libs ${LIBGPR2_TYPES:%=install-lib-%} install-tools

install-libs: uninstall-libs ${LIBGPR2_TYPES:%=install-lib-%}

install-lib-%:
	${INSTALLER} -XLIBRARY_TYPE=$* -XXMLADA_BUILD=$* \
		--build-name=$* \
		--build-var=LIBRARY_TYPE \
		--build-var=GPR2_LIBRARY_TYPE \
		${GPR2}

install-tools: uninstall-tools
	${INSTALLER} -XLIBRARY_TYPE=static -XXMLADA_BUILD=static \
		--build-name=static --mode=usage ${GPR2TOOLS} ${AP_GPR2}

#########
# setup #
#########

.SILENT: setup setup2

setup:
	echo "prefix=${prefix}" > makefile.setup
	echo "ENABLE_SHARED=${ENABLE_SHARED}" >> makefile.setup
	echo "GPR2_BUILD=${GPR2_BUILD}" >> makefile.setup
	echo "PROCESSORS=${PROCESSORS}" >> makefile.setup
	echo "PROFILER=${PROFILER}" >> makefile.setup
ifneq (${HOST},${TARGET})
	echo "TARGET=${TARGET}" >> makefile.setup
endif
	echo "GPR2KBDIR=${GPR2KBDIR}" >> makefile.setup
	echo "GPR2_EDGE_TOOLS_PREFIX=${GPR2_EDGE_TOOLS_PREFIX}" >> makefile.setup
	echo "PYTHON=${PYTHON}" >> makefile.setup
	echo "LOCAL_GPR2=${LOCAL_GPR2}" >> makefile.setup

setup2: setup
	echo "GPRINSTALL=\"${BUILD_ROOT}/${GPR2_BUILD}/obj-tools/gprinstall\"" >> makefile.setup

###########
# Cleanup #
###########

distclean: clean ${BUILD_TYPES:%=clean-buildtype-%}
	rm -rf ${LANGKIT_GENERATED_SRC}
	rm -f makefile.setup

clean: clean-tools ${LIBGPR2_TYPES:%=clean-libtype-%}
	rm -rf ${KB_BUILD_DIR}
	rm -rf ${BUILD_ROOT}/autoconf
	make -C ${SOURCE_DIR}/langkit clean DEST="${CURDIR}/${LANGKIT_GENERATED_SRC}"
	make -C ${SOURCE_DIR}/doc clean

clean-libtype-%:
	-${CLEANER} -XLIBRARY_TYPE=$* -P ${GPR2}

clean-buildtype-%:
	rm -rf ${BUILD_ROOT}/$*

clean-tools:
	-${CLEANER} -XLIBRARY_TYPE=static -P ${GPR2TOOLS} ${AP_GPR2}

#################
# Documentation #
#################

${DOCOUT}: force

docgen:
	${GPRDOC} > ${DOCOUT}
	${GPRDOC} --display=json > ${SOURCE_DIR}/testsuite/tests/gprdoc/attrs.json
	make -C ${SOURCE_DIR}/doc gen GPRDOC_FILE="../${DOCOUT}"


###########
# Langkit #
###########

# Langkit parser (GPR + Ada support)
build-langkit: $(wildcard ${SOURCE_DIR}/langkit/language/**/*.py) ${FORCE_PARSER_GEN}
	${MAKE} -C ${SOURCE_DIR}/langkit setup DEST="${SOURCE_DIR}/generated" PYTHONEXE=${PYTHON}

update-langkit-sources:
	rm -rf ${SOURCE_DIR}/langkit/sustained/src
	cp -R ${SOURCE_DIR}/langkit/generated/src ${SOURCE_DIR}/langkit/sustained/src

clean-langkit:
	make -C ${SOURCE_DIR}/langkit clean DEST="${SOURCE_DIR}/generated"

update-langkit: build-langkit update-langkit-sources clean-langkit

=== doc/Makefile ===
# Makefile for Sphinx documentation

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = .
SOURCEDIR     = .

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) \
		  -c $(SOURCEDIR)/share \
		  -d $(BUILDDIR)/$*/doctrees \
		  $(SOURCEDIR)
FMT_LIST=html txt info pdf
DOC_NAME=gprbuild_ug
CP=cp

WORK_DIR=__python__
GPRDOC_FILE=
OUT_FILE=gprbuild_ug/attributes.rst

-include ../makefile.setup

.PHONY: help clean

all: $(foreach fmt, $(FMT_LIST), $(fmt))

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  pdf        to make LaTeX files and run them through pdflatex"
	@echo "  txt        to make text files"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make info files"
	@echo "  all                 to build documentation in all formats"
	@echo ""
	@echo "source and location can be overriden using SOURCEDIR and BUILDDIR variables"

clean:
	-rm -rf $(BUILDDIR)/html \
		$(BUILDDIR)/pdf \
		$(BUILDDIR)/txt \
		$(BUILDDIR)/info \
		$(BUILDDIR)/doctrees \
		${WORK_DIR}/metadata/__pycache__ \
		${GPRDOC_FILE} \
		share/__pycache__

html: force
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

pdf: force
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
	cp $(SOURCEDIR)/share/sphinx.sty $(BUILDDIR)/pdf
	$(MAKE) -C $(BUILDDIR)/pdf all-pdf LATEXOPTS="-interaction=nonstopmode"

txt: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/txt
	$(MAKE) -C $(BUILDDIR)/txt plaintext

info: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/info
	$(MAKE) -C $(BUILDDIR)/info info

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/texinfo

gen:
	python3 ${WORK_DIR}/generate_gpr2_documentation.py --input=${GPRDOC_FILE} --output=${OUT_FILE}

force:

=== PKGBUILD ===

_realname=gpr
pkgbase=mingw-w64-${_realname}
pkgname=${MINGW_PACKAGE_PREFIX}-${_realname}
pkgver=24.0.0
pkgrel=2
pkgdesc="The framework for analyzing the GNAT Project (GPR) files (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64')
url="https://github.com/AdaCore/gpr"
msys2_references=(
  'aur: gpr'
  'gentoo: dev-ada/gpr'
)
license=('spdx:(Apache-2.0 WITH LLVM-exception) AND GPL-3.0-or-later')
makedepends=("${MINGW_PACKAGE_PREFIX}-gcc-ada"
             "${MINGW_PACKAGE_PREFIX}-gprbuild"
             "${MINGW_PACKAGE_PREFIX}-python-e3-core")
depends=("${MINGW_PACKAGE_PREFIX}-gnatcoll-core"
         "${MINGW_PACKAGE_PREFIX}-gnatcoll-iconv"
         "${MINGW_PACKAGE_PREFIX}-gnatcoll-gmp"
         "${MINGW_PACKAGE_PREFIX}-python-funcy"
         "${MINGW_PACKAGE_PREFIX}-python-mako"
         "${MINGW_PACKAGE_PREFIX}-python-docutils")
source=("https://github.com/AdaCore/gpr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz")
sha256sums=('6a7d03d57e2070c2d59561771c8d0be3a4d2dcd2d862d212d06583dc59f64b3a')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  make setup prefix="${pkgdir}${MINGW_PREFIX}" GPR2KBDIR=${MINGW_PREFIX}/share/gprconfig
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"

  make
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Without -j1 concurrent gprinstall processes may crash:
  #
  #     raised ADA.IO_EXCEPTIONS.END_ERROR : a-tigeli.adb:96
  #     make: *** [Makefile:209: install-lib-static-pic] Error 1
  #
  # Inspired by: https://github.com/AdaCore/gprbuild/issues/41#issuecomment-396234433
  #
  make -j1 install prefix="${pkgdir}${MINGW_PREFIX}"

  # These conflict with the binaries from 'gprbuild'.
  #
  rm "${pkgdir}${MINGW_PREFIX}"/bin/gprclean.exe
  rm "${pkgdir}${MINGW_PREFIX}"/bin/gprconfig.exe
  rm "${pkgdir}${MINGW_PREFIX}"/bin/gprinstall.exe
  rm "${pkgdir}${MINGW_PREFIX}"/bin/gprls.exe

  # Copy License Files
  install -Dm644 -t "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}" \
    LICENSE COPYING3
}
